#
# spec file for package dee
#
# Copyright (c) 2017 SUSE LINUX GmbH, Nuernberg, Germany.
#
# All modifications and additions to the file contributed by third parties
# remain the property of their copyright owners, unless otherwise agreed
# upon. The license for this file, and modifications and additions to the
# file, is the same license as for the pristine package itself (unless the
# license for the pristine package is not an Open Source License, in which
# case the license is the MIT License). An "Open Source License" is a
# license that conforms to the Open Source Definition (Version 1.9)
# published by the Open Source Initiative.

# Please submit bugfixes or comments via http://bugs.opensuse.org/
#


%define soname  libdee
%define sover   1_0-4
%define _version 1.2.7+17.10.20170616
Name:           dee
Version:        1.2.7+bzr20170616
Release:        lp151.2.2
Summary:        Library that uses D-Bus to provide objects
License:        LGPL-3.0
Group:          System/Libraries
URL:            https://launchpad.net/dee
Source:         https://launchpad.net/ubuntu/+archive/primary/+files/%{name}_%{_version}.orig.tar.gz
BuildRequires:  fdupes
BuildRequires:  gnome-common
BuildRequires:  libicu-devel >= 4.6
BuildRequires:  pkgconfig
BuildRequires:  python
BuildRequires:  python3
BuildRequires:  vala
BuildRequires:  pkgconfig(glib-2.0)
BuildRequires:  pkgconfig(gobject-2.0)
BuildRequires:  pkgconfig(gobject-introspection-1.0)

%description
Libdee is a library that uses D-Bus to provide objects allowing one
to create Model-View-Controller type applications across D-Bus.
It also consists of utility objects which extend D-Bus allowing
peer-to-peer discoverability of known objects without needing a
central registrar.

%package -n %{soname}-%{sover}
Summary:        Library that uses D-Bus to provide objects
Group:          System/Libraries

%description -n %{soname}-%{sover}
Libdee is a library that uses D-Bus to provide objects allowing one
to create Model-View-Controller type applications across D-Bus.
It also consists of utility objects which extend D-Bus allowing
peer-to-peer discoverability of known objects without needing a
central registrar.

%package -n typelib-1_0-Dee-1_0
Summary:        Library that uses D-Bus to provide objects -- Introspection bindings
Group:          System/Libraries

%description -n typelib-1_0-Dee-1_0
Libdee is a library that uses D-Bus to provide objects allowing one
to create Model-View-Controller type applications across D-Bus.
It also consists of utility objects which extend D-Bus allowing
peer-to-peer discoverability of known objects without needing a
central registrar.

This package provides the GObject Introspection bindings for libdee.

%if 0%{?suse_version} > 1320 || 0%{?sle_version} > 120200
%package -n python2-gobject-Dee
%else
%package -n python-gobject-Dee
%endif
Summary:        Python bindings for GObject/Dee
Group:          Development/Languages/Python
Requires:       %{soname}-%{sover} = %{version}
# python-dee was last used in openSUSE Leap 14.3.
Provides:       python-dee = %{version}
Obsoletes:      python-dee < %{version}
%if 0%{?suse_version} > 1320
Requires:       python2-gobject
Supplements:    packageand(python2-gobject:%{soname}-%{sover})
%else
Requires:       python-gobject
Supplements:    packageand(python-gobject:%{soname}-%{sover})
%endif
%if 0%{?suse_version} > 1320 || 0%{?sle_version} > 120200
# python-gobject-Dee was last used in openSUSE Leap 14.2.
Provides:       python-gobject-Dee = %{version}
Obsoletes:      python-gobject-Dee < %{version}
%endif

%if 0%{?suse_version} > 1320 || 0%{?sle_version} > 120200
%description -n python2-gobject-Dee
%else
%description -n python-gobject-Dee
%endif
Libdee is a library that uses D-Bus to provide objects allowing one
to create Model-View-Controller type applications across D-Bus.
It also consists of utility objects which extend D-Bus allowing
peer-to-peer discoverability of known objects without needing a
central registrar.

This package contains the Python Dee bindings for GObject.

%package -n python3-gobject-Dee
Summary:        Python bindings for GObject/Dee
Group:          Development/Languages/Python
Requires:       %{soname}-%{sover} = %{version}
Requires:       python3-gobject
Supplements:    packageand(python3-gobject:%{soname}-%{sover})

%description -n python3-gobject-Dee
Libdee is a library that uses D-Bus to provide objects allowing one
to create Model-View-Controller type applications across D-Bus.
It also consists of utility objects which extend D-Bus allowing
peer-to-peer discoverability of known objects without needing a
central registrar.

This package contains the Python Dee bindings for GObject.

%package devel
Summary:        Development files for dee
Group:          Development/Libraries/Other
Requires:       %{soname}-%{sover} = %{version}
Requires:       python3-gobject-Dee = %{version}
Requires:       typelib-1_0-Dee-1_0 = %{version}
%if 0%{?suse_version} > 1320 || 0%{?sle_version} > 120200
Requires:       python2-gobject-Dee = %{version}
%else
Requires:       python-gobject-Dee = %{version}
%endif

%description devel
This package provides the development files for dee.

Libdee is a library that uses D-Bus to provide objects allowing one
to create Model-View-Controller type applications across D-Bus.
It also consists of utility objects which extend D-Bus allowing
peer-to-peer discoverability of known objects without needing a
central registrar.

%prep
%setup -q -c

%build
NOCONFIGURE=1 gnome-autogen.sh
%global _configure ../configure
for pyver in %{py_ver} %{py3_ver}; do
    mkdir -p "build-py$pyver"
    pushd "build-py$pyver"
    export PYTHON="python$pyver"
    %configure \
      --disable-static           \
      --disable-maintainer-flags \
      --enable-introspection
    make %{?_smp_mflags} V=1
    popd
done

%install
%make_install -C build-py%{py_ver}
%make_install -C build-py%{py3_ver}

%fdupes %{buildroot}%{python_sitearch}/
%fdupes %{buildroot}%{python3_sitearch}/
find %{buildroot} -type f -name "*.la" -delete -print

%post -n %{soname}-%{sover} -p /sbin/ldconfig

%postun -n %{soname}-%{sover} -p /sbin/ldconfig

%files -n %{soname}-%{sover}
%doc ChangeLog README COPYING
%{_libdir}/libdee-1.0.so.*

%files -n typelib-1_0-Dee-1_0
%{_libdir}/girepository-1.0/Dee-1.0.typelib

%if 0%{?suse_version} > 1320 || 0%{?sle_version} > 120200
%files -n python2-gobject-Dee
%else
%files -n python-gobject-Dee
%endif
%dir %{python_sitearch}/gi/
%dir %{python_sitearch}/gi/overrides/
%{python_sitearch}/gi/overrides/*

%files -n python3-gobject-Dee
%dir %{python3_sitearch}/gi/
%dir %{python3_sitearch}/gi/overrides/
%{python3_sitearch}/gi/overrides/*

%files devel
%{_bindir}/dee-tool
%{_includedir}/dee-1.0/
%{_libdir}/libdee-1.0.so
%{_libdir}/pkgconfig/dee-1.0.pc
%{_libdir}/pkgconfig/dee-icu-1.0.pc
%{_datadir}/gir-1.0/Dee-1.0.gir
%dir %{_datadir}/vala/
%dir %{_datadir}/vala/vapi/
%{_datadir}/vala/vapi/dee-1.0.deps
%{_datadir}/vala/vapi/dee-1.0.vapi

%changelog
* Sun Dec 17 2017 sor.alexei@meowr.ru
- Update to version 1.2.7+bzr20170616 (changes since 1.2.7):
  * Disconnect signal handlers when unreffing GDBusServer
    (lp#1246263).
  * Fix new warnings with GCC 5+ (lp#1428299).
  * Fix misleading indentation.
- Rename python-dee to python-gobject-Dee to reflect its meaning.
- Build for Python3.
- Name the Python2 package python2-gobject-Dee on
  openSUSE Leap 14.2.
- Make the development package fetch python-gobject-Dee packages.
- Spec cleanup.
* Fri Jun 19 2015 dimstar@opensuse.org
- Pass --disable-maintainer-flags to configure: this flag is for
  upstream maintainers, injecting -Werror into CFLAGS.
* Fri Jul  4 2014 i@marguerite.su
- Update to version 1.2.7:
  + Added begin and end changeset API.
  + Bugs fixed: lp#1246263.
- Drop dee-fix-lp1076027.patch: upstream fixed in 1.2.0.
* Fri Dec 27 2013 zaitor@opensuse.org
- Add dee-fix-lp1076027.patch, Dee.SharedModel doesn't get
  invalidated when the leader changes (lp#1076027).
* Sun Sep 16 2012 zaitor@opensuse.org
- Update to version 1.0.14:
  + Bugs fixed: lp#1030092.
- Changes of version 1.0.12:
  + Bugs fixed: lp#988443, lp#1017277.
* Sat Apr 14 2012 dimstar@opensuse.org
- Update to version 1.0.10:
  + Bugs fixed: lp#938382, lp#953978, lp#963991.
* Wed Mar 28 2012 vuntz@opensuse.org
- Update to version 1.0.8:
  + Bug fixes: lp#956882, lp#959458.
* Tue Mar 13 2012 zaitor@opensuse.org
- Update to version 1.0.6:
  + Provide a way to have a ReadOnly model (lp#675565).
  + Several optimizations for speed.
  + Add new --watch-changes option for dee-tool, for debugging.
  + Other bug fixes: lp#933111, lp#933131, lp#940419.
- Fixed sourceurl to actually point to source.
* Fri Feb 17 2012 dimstar@opensuse.org
- Update to version 1.0.4:
  + Make DeeTransaction insert rows in an appending manner (instead
    of prepending) during commit() (lp#924353)
* Sat Feb  4 2012 zaitor@opensuse.org
- Update to version 1.0.2:
  + Add advanced transliteration support using ICU.
  + Bugs fixed: lp#773197, lp#916783, lp#917761.
- Add icu-devel BuildRequires: new dependency.
* Fri Jan 13 2012 dimstar@opensuse.org
- Update to version 1.0.0:
  + Bugs fixed: lp#905463, lp#894023, lp#900629, lp#904293,
    lp#904299, lp#913128, lp#622446, lp#901098, lp#901100,
    lp#912675, lp#911667.
- Split typelib file into typelib-1_0-Dee-1_0 subpackage.
- Add typelib-1_0-Dee-1_0 Requires to the -devel subpackage.
- Rename libdee-1_0-1 to libdee-1_0-4, following the upstream
  soname change.
* Mon Oct 17 2011 dimstar@opensuse.org
- Update to version 0.5.22:
  + Various bug fixes, including:
  - lp#845416: Dee.Model.set_schema() broken in pygi
  - lp#857432: More strict error checkin in DeeSequenceModel to
    help consumers.
  + Code changes to help broken users of the library find issues.
- Rename subpackage to libdee-1_0-1, following the soname bump.
* Fri Sep 30 2011 coolo@suse.com
- add libtool as buildrequire to make the spec file more reliable
* Thu Sep 22 2011 vuntz@opensuse.org
- Remove unneeded pkgconfig(dbus-1) and pkgconfig(dbus-glib-1)
  BuildRequires.
- Change vala-devel BuildRequires to vala as we only need the vala
  compiler.
- Add explicit libdee-%%{soname} and python-gobject Requires to
  python-dee subpackage: this package provides overrides for the
  introspection-based bindings, so we need python-gobject and the
  typelib to be installed.
- Add Supplement for packageand(libdee-%%{soname}:python-gobject) to
  python-dee, to make sure that the overrides are installed by
  default when introspection-based python bindings can be used.
- Remove unneeded pkg-config and python-dee Requires in devel
  subpackage.
* Wed Sep 14 2011 nmarques@opensuse.org
- Update to 0.5.20
  + No upstream changelog, 4 bug fixes: lp#838321, lp#818245,
    lp#838320, lp#710553.
* Fri Apr 15 2011 nmo.marques@gmail.com
- Update to version 0.5.18:
  + Leak in DeeSharedModel when committing remote transaction
    (lp#757916);
  + Dee API docs broken on DeeResourceManager (lp#760496).
* Thu Mar 24 2011 nmo.marques@gmail.com
- Update to version 0.5.16:
  + compiz crashed with SIGSEGV in g_atomic_int_exchange_and_add()
    lp#733343.
  + Implement DeeFilters for restrictions and localized sorting
    lp#736875.
  + Dee: compiz crashed with SIGSEGV in
    PlaceEntryRemote::ActivateResult() lp#733250.
- New subpackage python-dee.
- Minor tweaks to comply with new package requirements.
- Added new configure option '--enable-introspection=yes'
* Tue Feb  1 2011 nmarques@opensuse.org
- Update to version 0.5.6:
  + Fix the freeze when places are installed due to a gvariant
    freeze on double freeing (lp#709264).
* Wed Jan 19 2011 nmarques@opensuse.org
- Update to version 0.5.4.
- Spec fixes, added soname var.
* Fri Dec 17 2010 nmarques@opensuse.org
- Initial package from upstream release: dee-0.5.0.tar.bz2
